__doc__="""
TrackedImage.py

Randolpho St. John
N2 The Net
randolphothegreat@yahoo.com

This module contians the Tracked Image class and methods
that zope needs to manipulate the class."""

__version__="0.1"

from OFS import Image
from AccessControl import ClassSecurityInfo
from Globals import HTMLFile
from Globals import InitializeClass 

class TrackedImage(Image.Image):
    """this class represents a Nursery Catalog. It is folderish, allowing
    users to add plant group Categories into the folder."""
    
    security = ClassSecurityInfo()
    meta_type = "Tracked Image"
    
    def index_html(self, REQUEST, RESPONSE):
        """override the Image's index_html method to allow us to update the hit counter
        on a hit"""

        self.numHits = self.numHits + 1
        # now return parent index_html call
        return Image.Image.index_html(self, REQUEST, RESPONSE)
    
    def __init__(self, id, title, file, content_type="", precondition=""):
        """constructor"""
        Image.Image.__init__(self, id, title, file, content_type, precondition)
        self.manage_addProperty("numHits", "0", "int")

    security.declareProtected("Add Tracked Images", "manage_addTrackedImageForm")
    manage_addTrackedImageForm = HTMLFile('dtml/imageAdd', globals())

    security.declareProtected("Add Tracked Images", "manage_addTrackedImage")
    def manage_addTrackedImage(self, id, file, title="", precondition="", content_type="", REQUEST=None):
        """need the damn docstring. copy much from Image.`manage_addImage"""
        id = str(id)
        title = str(title)
        content_type = str(content_type)
        precondition = str(precondition)
        id, title = Image.cookId(id, title, file)
        self=self.this()
        self._setObject(id, TrackedImage(id, title, "", content_type, precondition))
        self._getOb(id).manage_upload(file)
        if content_type:
            self._getOb(id).content_type = content_type
        if REQUEST is not None:
            try: url=self.DestinationURL()
            except: url=REQUEST['URL1']
            REQUEST.RESPONSE.redirect("%s/manage_main" % url)
        return id

InitializeClass(TrackedImage)